/*
autor:  Marc-Antoine Drouin
  email: drouim@iro.umontreal.ca

  description: constant such as image path and parameters for stereo
  
  Copyright (c) 2005 Marc-Antoine Drouin


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



*/

#ifndef CONST_H
#define CONST_H





/* mask smoothing parameter */
#define GAMA 19
/* smoothing parameter */
#define LAMBDA 20
/* maximum number of iteration before convergence is ensure */
#define ITERATION 1 		/* 1.78 % error */
//#define ITERATION 4 		/* 1.62 % error */
//#define ITERATION 8 		/* 1.60 % error */
//#define ITERATION 16 		/* 1.57 % error */



/* using pot model for smoothing else used a linear smoothing model */
#define ROBUST
/* parameter for   head and lamp scene*/
 #define GROUNDTRUE "truedisp.pgm" 
#define FACTOR_SAVE 16  	/* disparity * FACTOR_SAVE = resulting intensity */
#define IMXSIZE 384
#define IMYSIZE 288 
#define IMZSIZE 3 		/* color image 3 chanel */
#define NBLABEL 16
#define  BORDERX 3
#define  BORDERY 3
#define LABEL_FACTOR 1
#define IMAGE_LEFT   "scene1.row3.col2.ppm"
#define IMAGE_RIGHT  "scene1.row3.col4.ppm"
#define IMAGE_REF    "scene1.row3.col3.ppm"
#define IMAGE_BOTTOM "scene1.row4.col3.ppm"
#define IMAGE_TOP    "scene1.row2.col3.ppm"







/* if you remove this there is no smoothing on the visibility mask */
#define KEEP_VISIBILITY


/* visibility of previous iteration are used this is the description used in the paper */
#define VISIBILITY_2D





/* remplace our scheme by nakamura */
//#define USED_NAKAMURA
/*the we used 2 camera mask or allow 1 camre mask*/
//#define NAKAMURA_2D




/* passing this point nothing should be changed */


/* access images 3 canals */
#define GETIMG(im,xx,yy,zz) ((im).Data[ ((yy)*IMXSIZE+(xx) ) * IMZSIZE  +(zz)] )
/*  access images one canal uselly the depth map */
#define GETDEPTH(im,xx,yy) ((im).Data[ ((yy)*IMXSIZE+(xx) )] )
/* likelehood term type  */
typedef  unsigned int OPT_TYPE ;
/*accumulation of likehood term  */
typedef  unsigned int OPT_ACC_TYPE ;
/* maximum value of likelehood used to indicate outside of image */
#define   OPT_MAX UINT_MAX
/* indicate that visibility mask are in unsigned int format */
typedef  unsigned int  MASK_TYPE;

#ifdef KEEP_VISIBILITY
OPT_TYPE SmoothCapacityX( short x1, unsigned char l1, short x2,unsigned char d, int occ,MASK_TYPE oldmask, MASK_TYPE * mask  ,void * v);
OPT_TYPE SmoothCapacityY( short x1, unsigned char l1, short x2,unsigned char d, int occ,MASK_TYPE oldmask, MASK_TYPE * mask ,void * v);
#else
OPT_TYPE SmoothCapacityX( short x1, unsigned char l1, short x2,unsigned char d, int occ, void * v);
OPT_TYPE SmoothCapacityY( short x1, unsigned char l1, short x2,unsigned char d, int occ, void * v);
#endif

OPT_TYPE SmoothCapacityNaka( short y1, unsigned char l1, short y2,unsigned char d, int occ, void * v);

#endif
