/*
autor:  Marc-Antoine Drouin
  email: drouim@iro.umontreal.ca

  description: stuff to open an image
  
  Copyright (c) 2005 Marc-Antoine Drouin
  Copyright (c) 1999-2005 Sbastien Roy

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



*/

#ifndef IMG_H
#define IMG_H


#include "const.h"

/****** Image support module ******/


/** Debugging assertions for interpolation **/
//#define NDEBUG
#ifdef NDEBUG
#define ASS_IMG_XY(x,y,xs,ys)
#define ASS_IMG_P(p,xs,ys)
#else
#define ASS_IMG_XY(x,y,xs,ys)	assert(x>=0 && y>=0 && x<xs && y<ys)
#define ASS_IMG_P(p,xs,ys)	assert(p>=0 && p<(xs*ys))
#endif


/** Information about the images **/
typedef struct{
	unsigned char Data[IMXSIZE*IMYSIZE*IMZSIZE];	/* Image Data, row order */
				/* In RGB mode : RGB RGB RGB RGB ... */
				/* NULL -> No Image loaded */
        } imginfo;

/*** Routines ***/


/** return 0 if ok, -1 if error **/
/** return the data in PData, and the size in P[XYZ]Size **/
/** ZSize=1 -> monochrome, ZSize=3 or 4 -> RGB or ARGB **/
/** If RGB : rgbrgbrgbrgb... **/
int LoadImage(char *Name,imginfo *I);

/*** Save in IRIS Format , If color, Data is RGB RGB RGB ... ***/
int SaveImageDepthMap(char *Name,imginfo *I);

int CleanImage(imginfo *I, unsigned char col) ;




#endif
